#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <cadef.h>
#include <iocsh.h>


static chid pv_channel;

static void on_get(struct event_handler_args args)
{
    printf("on get\n");
    printf("count = %ld\n", args.count);
}

static void on_ca_connect(struct connection_handler_args args)
{
    printf("on connect\n");
    ca_array_get_callback(3, 0, pv_channel, on_get, NULL);
}

int main(int argc, char **argv)
{
    bool early_create = argc > 1  &&  *argv[1] == '1';
    printf("Creating CA context %s\n", early_create ? "early" : "late");

    if (early_create)
        ca_context_create(1);
    iocsh("TEST.cmd");
    if (!early_create)
        ca_context_create(1);

    ca_create_channel("TESTPV", on_ca_connect, NULL, 0, &pv_channel);

    sleep(1);
    return 0;
}
